/* vidtext.c
 *
 * Taken from 'Exploring Turbo C's text mode programming functions' by
 * Richard Hale Shaw as published in 'Inside Turbo C', the Cobb Group. 
* This program demonstrates the use of Turbo C's text mode video fcts.
*/
#include    <conio.h>
#include    <stdio.h>
#include    <alloc.h>
#include    <stdlib.h>

#define  SAVE        1
#define  RESTORE     0

/* function prototypes */
void Windowgetstr (char *str);
void error_exit (unsigned retcode, char *message);
void WindowCopy (int top, int left);
void WindowCreate (int left, int top, int right, int bottom,
		 int foreground, int background);
void Windowputs (int col, int row, char *str);
void Screen(int save);
void main ();


void main(void)
	{
	int i;
	char name[80];
	Screen(SAVE);
	WindowCreate(10, 10, 60, 20, YELLOW, MAGENTA);
	*name = '\0';
	while(!(*name))
		{
		cputs("What is your name? ");
		Windowgetstr(name);
		gotoxy(1, 1);
		}
	clreol();

	for(i = 0; i < 25; i++)
		cprintf("Hello, %s!\r\n", name);
	cputs("press any key...");
	getch();
	delline();

	WindowCopy(5, 20);
	getch();

	Screen(RESTORE);
	}
		/* saves/restores screen - assumes 80X25 color mode */
void Screen(int save)
	{
	static int row, col;
	static unsigned screen_buffer[80*25];
	if (save)
		{
		textmode(C80);
		row = wherey();
		col = wherex();
		gettext(1, 1, 80, 25, screen_buffer);
		}
	else
		{
		window(1, 1, 80, 25);
		normvideo();
		puttext(1, 1, 80, 25, screen_buffer);
		gotoxy(col, row);
		}
	}
			/* copies current window to new coordinates */
void WindowCopy(int top, int left)
	{
	struct text_info cw, cw2;
	int width, height;

	gettextinfo (&cw);
					   /* create outline window */
	window(cw.winleft-1, cw.wintop-1, cw.winright+1,
		cw.winbottom+1);
	gettextinfo(&cw2);

	height = (cw2.winbottom - cw2.wintop);
	width = (cw2.winright - cw2.winleft);
	window(left, top, left+width, top+height);
	textattr(cw2.attribute);

	movetext(cw2.winleft, cw2.wintop, cw2.winright, cw2.winbottom,
		left, top);
	window(left+1, top+1, left+width-1, top+height-1);
	gotoxy(cw.curx, cw.cury);
	}
					      /* general exit routine */

void error_exit(unsigned retcode, char *message)
	{
	printf("Error %u returned from %s\n", retcode, message);
	exit(retcode);
	}

/* reads string from current cursor line in window; terminate when user
   presses RETURN or edge of window is reached */

void Windowgetstr(char *str)
	{
	struct text_info curwin;
	int spaceleft, i;
	gettextinfo(&curwin);
	spaceleft = curwin.winright - (curwin.winleft+curwin.curx) + 1;
	for(i = 0; i < spaceleft; i++)
		{
		str[i] = getch();
		if (str[i] == '\r')
			break;
		}
	str[i] = NULL;
	}
    /* write a string at the passed coordinates to the current window */
void Windowputs(int col, int row, char *str)
	{
	gotoxy(col, row);
	cputs(str);
	}

 /* write a character at the passed coordinates to the current window */
void Windowputch(int col, int row, char c)
	{
	gotoxy(row, col);
	putchar (c);
	}

	/* create a bordered, colored window at the passed coordinates;
	      resulting active window is the area INSIDE the border. */

void WindowCreate(int left, int top, int right, int bottom,
		int foreground, int background)
	{
	int i, width, height;

	window(left, top, right, bottom);
	textcolor(foreground);
	textbackground(background);
	clrscr();

	Windowputs(1, 1, "");
	for (i = 2, width = right - left; i <= width; i++)
		Windowputs(i, 1, "");

	Windowputs(i, 1, "");

	for (i = 2, height = bottom - top; i <= height; i++)
		{
		Windowputs(1, i, "");
		Windowputs(width + 1, i, "");
		}
	Windowputs(1, ++height, "");

	for (i = 2; i <= width; i++)
		Windowputs(i, height, "");

	Windowputch(width + 1, height, '');
	window(left + 1, top + 1, right - 1, bottom - 1);
	}









